/** 
 * 
 * Copyright 2005 LogicBlaze, Inc. http://www.logicblaze.com
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.servicemix.jbi.deployment;

import java.util.Arrays;
import java.util.List;

/**
 * @version $Revision: 1.3 $
 */
public class ClassPath {
    private String[] pathElements;

    public ClassPath() {
    }

    public ClassPath(String[] pathElements) {
        this.pathElements = pathElements;
    }

    public String[] getPathElements() {
        return pathElements;
    }

    public void setPathElements(String[] pathElements) {
        this.pathElements = pathElements;
    }

    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof ClassPath)) {
            return false;
        }

        final ClassPath classPath = (ClassPath) o;

        if (!Arrays.equals(pathElements, classPath.pathElements)) {
            return false;
        }

        return true;
    }

    public String toString() {
        StringBuffer buffer = new StringBuffer("ClassPath[");
        for (int i = 0; i < pathElements.length; i++) {
            String pathElement = pathElements[i];
            if (i > 0) {
                buffer.append(", ");
            }
            buffer.append(pathElement);
        }
        return buffer.toString();
    }

    public List getPathList() {
        return Arrays.asList(pathElements);
    }

    public void setPathList(List list) {
        pathElements = new String[list.size()];
        list.toArray(pathElements);
    }
}
